Isen.DotNet.Web/Models/ErrorViewModel.cs
using System;

namespace Isen.DotNet.Web.Models
{
    public class ErrorViewModel
    {
        public string RequestId { get; set; }

        public bool ShowRequestId => !string.IsNullOrEmpty(RequestId);
    }
}

Isen.DotNet.Web/Controllers/AddressController.cs
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Isen.DotNet.Web.Models;
using Isen.DotNet.Library.Repositories.Interfaces;
using Isen.DotNet.Library.Models.Implementation;
using Microsoft.Extensions.Logging;

namespace Isen.DotNet.Web.Controllers
{
    public class AddressController : BaseController<Address>
    {
        public AddressController(
            ILogger<AddressController> logger,
            IAddressRepository repository)
            : base(logger, repository)
        {
    }
}
}

Isen.DotNet.Web/Controllers/CategoryController.cs
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Isen.DotNet.Web.Models;
using Isen.DotNet.Library.Repositories.Interfaces;
using Isen.DotNet.Library.Models.Implementation;
using Microsoft.Extensions.Logging;

namespace Isen.DotNet.Web.Controllers
{
    public class CategoryController : BaseController<Category>
    {
        public CategoryController(
            ILogger<CategoryController> logger,
            ICategoryRepository repository)
            : base(logger, repository)
        {
    }
}
}

Isen.DotNet.Web/Controllers/DepartementController.cs
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Isen.DotNet.Web.Models;
using Isen.DotNet.Library.Repositories.Interfaces;
using Isen.DotNet.Library.Models.Implementation;
using Microsoft.Extensions.Logging;

namespace Isen.DotNet.Web.Controllers
{
    public class DepartementController : BaseController<Departement>
    {
        public DepartementController(
            ILogger<DepartementController> logger,
            IDepartementRepository repository)
            : base(logger, repository)
        {
    }
}
}

Isen.DotNet.Web/Controllers/HomeController.cs
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Isen.DotNet.Web.Models;

namespace Isen.DotNet.Web.Controllers
{
    public class HomeController : Controller
    {
        public IActionResult Index()
        {
            return View();
        }

        public IActionResult About()
        {
            ViewData["Message"] = "Your application description page.";

            return View();
        }

        public IActionResult Contact()
        {
            ViewData["Message"] = "Your contact page.";

            return View();
        }

        public IActionResult Error()
        {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }
    }
}

Isen.DotNet.Web/Controllers/PoiController.cs
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Isen.DotNet.Web.Models;
using Isen.DotNet.Library.Repositories.Interfaces;
using Isen.DotNet.Library.Models.Implementation;
using Microsoft.Extensions.Logging;

namespace Isen.DotNet.Web.Controllers
{
    public class PoiController : BaseController<Poi>
    {
        public PoiController(
            ILogger<PoiController> logger,
            IPoiRepository repository)
            : base(logger, repository)
        {
    }
}
}

Isen.DotNet.Web/Controllers/TownController.cs
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Isen.DotNet.Web.Models;
using Isen.DotNet.Library.Repositories.Interfaces;
using Isen.DotNet.Library.Models.Implementation;
using Microsoft.Extensions.Logging;

namespace Isen.DotNet.Web.Controllers
{
    public class TownController : BaseController<Town>
    {
        public TownController(
            ILogger<TownController> logger,
            ITownRepository repository)
            : base(logger, repository)
        {
    }
}
}

Isen.DotNet.Web/Controllers/_BaseApiController.cs
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Isen.DotNet.Web.Models;
using Isen.DotNet.Library.Repositories.Interfaces;
using Isen.DotNet.Library.Models.Implementation;
using Microsoft.Extensions.Logging;
using Isen.DotNet.Library.Models.Base;
using System.Dynamic;

namespace Isen.DotNet.Web.Controllers
{
    public abstract partial class BaseController<T> : Controller
        where T : BaseModel
    {
        [HttpGet]
        [Route("api/[controller]")]
        public virtual JsonResult GetAll()
        {
            var all = _repository
                .GetAll()
                .Select(t => t.ToDynamic())
                .ToList();
            return Json(all);
        }

        [HttpGet]
        [Route("api/[controller]/{id}")]
        public virtual JsonResult GetById(int id)
        {
            var single = _repository.Single(id);
            return Json(single);
        }

        [HttpPost]
        [Route("api/[controller]")]
        public virtual JsonResult Create([FromBody] T model)
        {
            _repository.Update(model);
            _repository.Save();
            return Json(model.ToDynamic());
        }

        [HttpPut]
        [Route("api/[controller]/{id}")]
        public virtual JsonResult Update(int? id, [FromBody] T model)
        {
            if (id == null || model == null || model.Id != id)
                return Json(null);

            _repository.Update(model);
            _repository.Save();
            return Json(model.ToDynamic());
        }

        [HttpDelete]
        [Route("api/[controller]/{id}")]
        public virtual IActionResult Remove(int? id)
        {
            if (id == null)
                return BadRequest();
            if (_repository.Single(id.Value) == null)
                return NotFound();
            _repository.Delete(id.Value);
            _repository.Save();
            return new NoContentResult();
        }
    }
}

Isen.DotNet.Web/Controllers/_BaseController.cs
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Isen.DotNet.Web.Models;
using Isen.DotNet.Library.Repositories.Interfaces;
using Isen.DotNet.Library.Models.Implementation;
using Microsoft.Extensions.Logging;
using Isen.DotNet.Library.Models.Base;

namespace Isen.DotNet.Web.Controllers
{
    public abstract partial class BaseController<T> : Controller
        where T : BaseModel
    {
        protected IBaseRepository<T> _repository;
        protected readonly ILogger<BaseController<T>> _logger;

        public BaseController(
            ILogger<BaseController<T>> logger,
            IBaseRepository<T> repository)
        {
            _repository = repository;
            _logger = logger;
        }

        public virtual IActionResult Index()
        {            
            var model = _repository.GetAll();
            return View(model);
        }

        public virtual IActionResult Detail(int? id)
        {
            // Pas d'id > form vide (création)
            if (id == null) return View();
            // Récupérer la ville et la passer à la vue
            var model = _repository.Single(id.Value);
            return View(model);
        }

        [HttpPost]
        public virtual IActionResult Detail(T model)
        {
            _repository.Update(model);
            _repository.Save();
            return RedirectToAction("Index");
        }

        public virtual IActionResult Delete(int? id)
        {
            if (id != null)
            {
                _repository.Delete(id.Value);
                _repository.Save();
            }
            return RedirectToAction("Index");
        }
    }
}

Isen.DotNet.Web/Views/Address/Detail.cshtml
@using Isen.DotNet.Library.Models.Implementation;
@using Isen.DotNet.Library.Repositories.Interfaces;
@{
    ViewData["Title"] = "Address (détail)";
}
@inject ITownRepository _townRepository;
@model Address
<div class="row">
    <div class="col-md-12">
        <h1>Détail d'une addresse <small>/address/detail</small></h1>
    </div>
</div>
<div class="row">
    <div class="col-md-12">
        <form class="form-horizontal" asp-action="Detail">
            <input type="hidden" value="@Model?.Id" asp-for="Id" />
            <div>
                <label for="TextLine" class="control-label">N° et Nom de Rue :</label>
                <input type="text" class="form-control"
                       id="TextLine" placeholder="N° et Nom de Rue"
                       value="@Model?.TextLine" asp-for="TextLine" />

                <div>
                    <label for="TownId">
                        Commune :
                    </label>
                    @Html.DropDownListFor(
                           // Champ du modèle (quelle ville faut-il sélectionner)
                           // Le moteur Razor sait que p est une Personne
                           // grace à @model Person
                           a => a.TownId,
                           // Remplissage de la liste
                           new SelectList(
                               // Liste des entités qui peuplent la liste
                               // voir @using et @inject en haut de fichier
                               _townRepository.GetAll(),
                               // Champ de clé
                               "Id",
                               // Champ d'affichage
                               "Name"),
                           // Item par défaut
                           "<Sélectionnez une commune>",
                           // Classe CSS
                           // Le @ n'est pas celui de Razor mais celui du C#
                           // Si on veut nommer une classe ou un champ avec un
                           // mot clé du langage, on le fait précéder d'un @
                           new { @class = "form-control" })
                </div>

                <label for="ZipCode" class="control-label">Code Postal :</label>
                <input type="text" class="form-control"
                       id="ZipCode" placeholder="Code Postal"
                       value="@Model?.ZipCode" asp-for="ZipCode" />

                <label for="Latitude" class="control-label">Latitude :</label>
                <input type="text" class="form-control"
                       id="Latitude" placeholder="Latitude"
                       value="@Model?.Latitude" asp-for="Latitude" />

                <label for="Longitude" class="control-label">Longitude :</label>
                <input type="text" class="form-control"
                       id="Longitude" placeholder="Longitude"
                       value="@Model?.Longitude" asp-for="Longitude" />
            </div>
            <br />
            <input type="submit" class="btn btn-primary" value="Valider" />
            <a class="btn btn-default"
               asp-controller="Address" asp-action="Index">Annuler</a>
        </form>
    </div>
</div>

Isen.DotNet.Web/Views/Address/Index.cshtml
@using Isen.DotNet.Library.Models.Implementation;
@{
    ViewData["Title"] = "Addresses";
}
@model IEnumerable<Address>
<div class="row">
    <div class="col-md-12">
        <h1>Adresses <small>/address/index</small></h1>
    </div>
</div>
<div class="row">
    <a class="btn btn-default"
       asp-controller="Address" asp-action="Detail">Ajouter une addresse...</a>
</div>
<div class="row">
    <table class="table table-striped">
        <thead>
            <tr>
                <th>#</th>
                <th>TextLine</th>
                <th>ZipCode</th>
                <th>Town</th>
                <th>Latitude</th>
                <th>Longitude</th>

                <th></th>
            </tr>
        </thead>
        <tbody>
            @foreach (var address in Model)
            {
            <tr>
                <td>@address.Id</td>
                <td>@address.TextLine</td>
                <td>@address.ZipCode</td>
                <td>@address.Town.Name</td>
                <td>@address.Latitude</td>
                <td>@address.Longitude</td>
                <td>
                    <a class="btn btn-default" asp-controller="Address" asp-action="Detail" asp-route-id="@address.Id">Editer</a>
                    &nbsp;
                    <a class="btn btn-danger" asp-controller="Address" asp-action="Delete" asp-route-id="@address.Id">Supprimer</a>
                </td>
            </tr>
            }
        </tbody>
    </table>
</div>

Isen.DotNet.Web/Views/Category/Detail.cshtml
@using Isen.DotNet.Library.Models.Implementation;
@{
    ViewData["Title"] = "Category (détail)";
}
@model Category
<div class="row">
    <div class="col-md-12">
        <h1>Détail d'une catégorie <small>/category/detail</small></h1>
    </div>
</div>
<div class="row">
    <div class="col-md-12">
        <form class="form-horizontal" asp-action="Detail">
            <input type="hidden" value="@Model?.Id" asp-for="Id" />
            <div>
                <label for="Name" class="control-label">Nom de la catégorie :</label>
                <input type="text" class="form-control"
                       id="Name" placeholder="Nom de la catégorie"
                       value="@Model?.Name" asp-for="Name" />

                <label for="Description" class="control-label">Description de la catégorie :</label>
                <input type="text" class="form-control"
                       id="Description" placeholder="Description de la catégorie"
                       value="@Model?.Description" asp-for="Description" />
            </div>
            <br />
            <input type="submit" class="btn btn-primary" value="Valider" />
            <a class="btn btn-default"
               asp-controller="Category" asp-action="Index">Annuler</a>
        </form>
    </div>
</div>

Isen.DotNet.Web/Views/Category/Index.cshtml
@using Isen.DotNet.Library.Models.Implementation;
@{
    ViewData["Title"] = "Categories";
}
@model IEnumerable<Category>
<div class="row">
    <div class="col-md-12">
        <h1>Categories <small>/category/index</small></h1>
    </div>
</div>
<div class="row">
    <a class="btn btn-default"
       asp-controller="Category" asp-action="Detail">Ajouter une categorie...</a>
</div>
<div class="row">
    <table class="table table-striped">
        <thead>
            <tr>
                <th>#</th>
                <th>Name</th>
                <th>Description</th>

                <th></th>
            </tr>
        </thead>
        <tbody>
            @foreach (var category in Model)
            {
                <tr>
                    <td>@category.Id</td>
                    <td>@category.Name</td>
                    <td>@category.Description</td>
                    <td>
                        <a class="btn btn-default" asp-controller="Category" asp-action="Detail" asp-route-id="@category.Id">Editer</a>
                        &nbsp;
                        <a class="btn btn-danger" asp-controller="Category" asp-action="Delete" asp-route-id="@category.Id">Supprimer</a>
                    </td>
                </tr>
            }
        </tbody>
    </table>
</div>

Isen.DotNet.Web/Views/Departement/Detail.cshtml
@using Isen.DotNet.Library.Models.Implementation;
@{
    ViewData["Title"] = "Departement (détail)";
}
@model Departement
<div class="row">
    <div class="col-md-12">
        <h1>Détail d'un departement <small>/departement/detail</small></h1>
    </div>
</div>
<div class="row">
    <div class="col-md-12">
        <form class="form-horizontal" asp-action="Detail">
            <input type="hidden" value="@Model?.Id" asp-for="Id" />
            <div>
                <label for="Name" class="control-label">Nom du departement :</label>
                <input type="text" class="form-control"
                       id="Name" placeholder="Nom du departement "
                       value="@Model?.Name" asp-for="Name" />

                <label for="Code" class="control-label">Code du departement :</label>
                <input type="text" class="form-control"
                       id="Code" placeholder="Code du departement"
                       value="@Model?.Code" asp-for="Code" />
            </div>
            <br />
            <input type="submit" class="btn btn-primary" value="Valider" />
            <a class="btn btn-default"
               asp-controller="Departement" asp-action="Index">Annuler</a>
        </form>
    </div>
</div>

Isen.DotNet.Web/Views/Departement/Index.cshtml
@using Isen.DotNet.Library.Models.Implementation;
@{
    ViewData["Title"] = "Departements";
}
@model IEnumerable<Departement>
<div class="row">
    <div class="col-md-12">
        <h1>Departement <small>/departement/index</small></h1>
    </div>
</div>
<div class="row">
    <a class="btn btn-default"
       asp-controller="Departement" asp-action="Detail">Ajouter un departement...</a>
</div>
<div class="row">
    <table class="table table-striped">
        <thead>
            <tr>
                <th>#</th>
                <th>Name</th>
                <th>Code</th>

                <th></th>
            </tr>
        </thead>
        <tbody>
            @foreach (var departement in Model)
            {
                <tr>
                    <td>@departement.Id</td>
                    <td>@departement.Name</td>
                    <td>@departement.Code</td>
                    <td>
                        <a class="btn btn-default" asp-controller="Departement" asp-action="Detail" asp-route-id="@departement.Id">Editer</a>
                        &nbsp;
                        <a class="btn btn-danger" asp-controller="Departement" asp-action="Delete" asp-route-id="@departement.Id">Supprimer</a>
                    </td>
                </tr>
            }
        </tbody>
    </table>
</div>

Isen.DotNet.Web/Views/Home/About.cshtml
@{
    ViewData["Title"] = "About";
    Layout = "_LayoutEmpty";
}
<div class="row">
    <div class="col-md-12">
        <h1>Home <small>/home/about</small></h1>
        <p>Ceci est le contenu de la vue Home, action About</p>
    </div>
</div>

Isen.DotNet.Web/Views/Home/Contact.cshtml
@{
    ViewData["Title"] = "Contact";
}
<div class="row">
    <div class="col-md-12">
        <h1>Home <small>/home/contact</small></h1>
        <p>Ceci est le contenu de la vue Home, action Contact</p>
    </div>
</div>

Isen.DotNet.Web/Views/Home/Index.cshtml
@{
    ViewData["Title"] = "Home";
    ViewData["Desc"] = "Description longue du site";

}
<div class="row">
    <div class="col-md-12">
        <h1>Home <small>/home/index</small></h1>
    </div>
</div>
<div class="row">
    <p> Groupe : GOUISSEM Seif + TAVAGNACCO Sandro </p>
</div>

Isen.DotNet.Web/Views/Poi/Detail.cshtml
@using Isen.DotNet.Library.Models.Implementation;
@using Isen.DotNet.Library.Repositories.Interfaces;
@{
    ViewData["Title"] = "Point d'intérêt (détail)";
}
@inject IAddressRepository _addressRepository;
@inject ICategoryRepository _categoryRepository;
@model Poi
<div class="row">
    <div class="col-md-12">
        <h1>Détail d'un point d'intérêt <small>/poi/detail</small></h1>
    </div>
</div>
<div class="row">
    <div class="col-md-12">
        <form class="form-horizontal" asp-action="Detail">
            <input type="hidden" value="@Model?.Id" asp-for="Id" />
            <div>
                <label for="Name" class="control-label">Nom du poi :</label>
                <input type="text" class="form-control"
                       id="Name" placeholder="Nom du poi"
                       value="@Model?.Name" asp-for="Name" />

                <label for="Description" class="control-label">Description du poi :</label>
                <input type="text" class="form-control"
                       id="Description" placeholder="Description du poi"
                       value="@Model?.Description" asp-for="Description" />

                <div>
                    <label for="CategoryId">
                        Categorie :
                    </label>
                    @Html.DropDownListFor(
              // Champ du modèle (quelle ville faut-il sélectionner)
              // Le moteur Razor sait que p est une Personne
              // grace à @model Person
              ca => ca.CategoryId,
              // Remplissage de la liste
              new SelectList(
                  // Liste des entités qui peuplent la liste
                  // voir @using et @inject en haut de fichier
                  _categoryRepository.GetAll(),
                  // Champ de clé
                  "Id",
                  // Champ d'affichage
                  "Name"),
              // Item par défaut
              "<Sélectionnez une categorie>",
              // Classe CSS
              // Le @ n'est pas celui de Razor mais celui du C#
              // Si on veut nommer une classe ou un champ avec un
              // mot clé du langage, on le fait précéder d'un @
              new { @class = "form-control" })
                </div>

                <div>
                    <label for="AddressId">
                        Addresse :
                    </label>
                    @Html.DropDownListFor(
                         // Champ du modèle (quelle ville faut-il sélectionner)
                         // Le moteur Razor sait que p est une Personne
                         // grace à @model Person
                         a => a.AddressId,
                         // Remplissage de la liste
                         new SelectList(
                             // Liste des entités qui peuplent la liste
                             // voir @using et @inject en haut de fichier
                             _addressRepository.GetAll(),
                             // Champ de clé
                             "Id",
                             // Champ d'affichage
                             "TextLine"),
                         // Item par défaut
                         "<Sélectionnez une addresse>",
                         // Classe CSS
                         // Le @ n'est pas celui de Razor mais celui du C#
                         // Si on veut nommer une classe ou un champ avec un
                         // mot clé du langage, on le fait précéder d'un @
                         new { @class = "form-control" })
                </div>

            </div>
            <br />
            <input type="submit" class="btn btn-primary" value="Valider" />
            <a class="btn btn-default"
               asp-controller="Poi" asp-action="Index">Annuler</a>
        </form>
    </div>
</div>

Isen.DotNet.Web/Views/Poi/Index.cshtml
@using Isen.DotNet.Library.Models.Implementation;
@{
    ViewData["Title"] = "Pois";
}
@model IEnumerable<Poi>
<div class="row">
    <div class="col-md-12">
        <h1>Points d'intérêt <small>/poi/index</small></h1>
    </div>
</div>
<div class="row">
    <a class="btn btn-default"
       asp-controller="Poi" asp-action="Detail">Ajouter un point d'intérêt...</a>
</div>
<div class="row">
    <table class="table table-striped">
        <thead>
            <tr>
                <th>#</th>
                <th>Name</th>
                <th>Description</th>
                <th>Category</th>
                <th>Address</th>

                <th></th>
            </tr>
        </thead>
        <tbody>
            @foreach (var poi in Model)
            {
            <tr>
                <td>@poi.Id</td>
                <td>@poi.Name</td>
                <td>@poi.Description</td>
                <td>@poi.Category.Name</td>
                <td>@poi.Address.TextLine</td>
                <td>
                    <a class="btn btn-default" asp-controller="Poi" asp-action="Detail" asp-route-id="@poi.Id">Editer</a>
                    &nbsp;
                    <a class="btn btn-danger" asp-controller="Poi" asp-action="Delete" asp-route-id="@poi.Id">Supprimer</a>
                </td>
            </tr>
            }
        </tbody>
    </table>
</div>

Isen.DotNet.Web/Views/Shared/_Footer.cshtml
<hr />
<footer>
    <p>&copy; 2018 - Yncrea</p>
</footer>

Isen.DotNet.Web/Views/Shared/_Nav.cshtml
<nav class="navbar navbar-inverse navbar-fixed-top">
    <div class="container">
        <div class="navbar-header">
            <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-collapse">
                <span class="sr-only">Toggle navigation</span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
            </button>
            <a asp-area="" asp-controller="Home" asp-action="Index" class="navbar-brand">my<strong>Web</strong>App</a>
        </div>
        <div class="navbar-collapse collapse">
            <ul class="nav navbar-nav">
                <li><a asp-area="" asp-controller="Home" asp-action="Index">Home</a></li>
                <!-- <li class="dropdown">
         <a href="#"
            class="dropdown-toggle"
            data-toggle="dropdown"
            role="button"
            aria-haspopup="true"
            aria-expanded="false">
             Villes
             <span class="caret"></span>
         </a>
         <ul class="dropdown-menu">
             <li><a asp-controller="City" asp-action="Index">Toutes...</a></li>
             <li><a asp-controller="City" asp-action="Detail">Ajouter...</a></li>
         </ul>
     </li>
     <li class="dropdown">
         <a href="#"
            class="dropdown-toggle"
            data-toggle="dropdown"
            role="button"
            aria-haspopup="true"
            aria-expanded="false">
             Personnes
             <span class="caret"></span>
         </a>
         <ul class="dropdown-menu">
             <li><a asp-controller="Person" asp-action="Index">Toutes...</a></li>
             <li><a asp-controller="Person" asp-action="Detail">Ajouter...</a></li>
         </ul>
     </li> -->
                <li class="dropdown">
                    <a href="#"
                       class="dropdown-toggle"
                       data-toggle="dropdown"
                       role="button"
                       aria-haspopup="true"
                       aria-expanded="false">
                        Categories
                        <span class="caret"></span>
                    </a>
                    <ul class="dropdown-menu">
                        <li><a asp-controller="Category" asp-action="Index">Toutes...</a></li>
                        <li><a asp-controller="Category" asp-action="Detail">Ajouter...</a></li>
                    </ul>
                </li>
                <li class="dropdown">
                    <a href="#"
                       class="dropdown-toggle"
                       data-toggle="dropdown"
                       role="button"
                       aria-haspopup="true"
                       aria-expanded="false">
                        Addresses
                        <span class="caret"></span>
                    </a>
                    <ul class="dropdown-menu">
                        <li><a asp-controller="Address" asp-action="Index">Toutes...</a></li>
                        <li><a asp-controller="Address" asp-action="Detail">Ajouter...</a></li>
                    </ul>
                </li>
                <li class="dropdown">
                    <a href="#"
                       class="dropdown-toggle"
                       data-toggle="dropdown"
                       role="button"
                       aria-haspopup="true"
                       aria-expanded="false">
                        POIs
                        <span class="caret"></span>
                    </a>
                    <ul class="dropdown-menu">
                        <li><a asp-controller="Poi" asp-action="Index">Toutes...</a></li>
                        <li><a asp-controller="Poi" asp-action="Detail">Ajouter...</a></li>
                    </ul>
                </li>
                <li class="dropdown">
                    <a href="#"
                       class="dropdown-toggle"
                       data-toggle="dropdown"
                       role="button"
                       aria-haspopup="true"
                       aria-expanded="false">
                        Communes
                        <span class="caret"></span>
                    </a>
                    <ul class="dropdown-menu">
                        <li><a asp-controller="Town" asp-action="Index">Toutes...</a></li>
                        <li><a asp-controller="Town" asp-action="Detail">Ajouter...</a></li>
                    </ul>
                </li>
                <li class="dropdown">
                    <a href="#"
                       class="dropdown-toggle"
                       data-toggle="dropdown"
                       role="button"
                       aria-haspopup="true"
                       aria-expanded="false">
                        Departements
                        <span class="caret"></span>
                    </a>
                    <ul class="dropdown-menu">
                        <li><a asp-controller="Departement" asp-action="Index">Tous...</a></li>
                        <li><a asp-controller="Departement" asp-action="Detail">Ajouter...</a></li>
                    </ul>
                </li>
                <li><a asp-area="" asp-controller="Home" asp-action="About">About</a></li>
                <li><a asp-area="" asp-controller="Home" asp-action="Contact">Contact</a></li>
            </ul>
        </div>
    </div>
</nav>

Isen.DotNet.Web/Views/Town/Index.cshtml
@using Isen.DotNet.Library.Models.Implementation;
@{
    ViewData["Title"] = "Communes";
}
@model IEnumerable<Town>
<div class="row">
    <div class="col-md-12">
        <h1>Communes <small>/town/index</small></h1>
    </div>
</div>
<div class="row">
    <a class="btn btn-default"
       asp-controller="Town" asp-action="Detail">Ajouter une commune...</a>
</div>
<div class="row">
    <table class="table table-striped">
        <thead>
            <tr>
                <th>#</th>
                <th>Name</th>
                <th>Latitude</th>
                <th>Longitude</th>
                <th>Departement</th>

                <th></th>
            </tr>
        </thead>
        <tbody>
            @foreach (var town in Model)
            {
            <tr>
                <td>@town.Id</td>
                <td>@town.Name</td>
                <td>@town.Latitude</td>
                <td>@town.Longitude</td>
                <td>@town.Departement.Name</td>
                <td>
                    <a class="btn btn-default" asp-controller="Town" asp-action="Detail" asp-route-id="@town.Id">Editer</a>
                    &nbsp;
                    <a class="btn btn-danger" asp-controller="Town" asp-action="Delete" asp-route-id="@town.Id">Supprimer</a>
                </td>
            </tr>
            }
        </tbody>
    </table>
</div>